import orderApi from '../../api/order'
import drawQrcode from '../../utils/weapp.qrcode.js'
// pages/order/order.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    orderId: 0,
    order: {},
    //1显示订单详情，2显示确认支付，取消订单，3显示删除订单
    orderStatus: 1,
    timer: {},
    codeUrl: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: async function (options) {
    var orderId = options.id;
    this.setData({
      orderId: orderId
    })
    let order = await orderApi.getOrderById(orderId);



  },
  //生成二维码
  createQrcode: function () {
    drawById.call(wx, "qrCode", {
      text: "1233", // 二维码内容
    })
  },

  createTimeClock: function () {
    var self = this;
    let order = this.data.order;
    let orderId = this.data.orderId;
    console.log(order.createTime)
    let orderCreateTime = new Date(order.createTime);
    let endTime = orderCreateTime.getTime() + 15 * 60 * 1000;
    // let endTime = orderCreateTime.getTime() + 30 * 1000;

    var timerID = setInterval(() => {
      let nowTime = new Date();
      let timer = endTime - nowTime;
      if (timer < 1) {
        clearInterval(timerID);
        orderApi.closeOrder(orderId);
        order.status = 3;
        self.setData({
          order
        })
      }
      let minute = Math.floor(timer / (60 * 1000));
      minute = minute < 0 ? 0 : minute;
      let second = Math.round((timer % (60 * 1000)) / 1000);
      this.setData({
        timer: {
          minute: minute,
          second: second
        }
      })
    }, 500);
  },
  cancelOrder: function () {
    let orderId = this.data.orderId;
    let order = this.data.order;
    var self = this;
    wx.showModal({
      title: '是否确认取消订单？',
      success(res) {
        if (res.confirm) {
          orderApi.closeOrder(orderId);
          order.status = 3;
          self.setData({
            order
          })
        } else if (res.cancel) {}

      },

    })
  },
  deleteOrder: async function () {
    let id = this.data.order.id;
    await orderApi.deleteOrder(id);
    wx.showToast({
      title: '删除成功',
      success: function () {
        setTimeout(() => {
          wx.switchTab({
            url: '../personorder/personorder',
          })
        }, 1000);

      }
    })

  },
  drawCode: function (writeOffCode) {
    let width = this.rpxToPx(280);
    drawQrcode({
      width: width,
      height: width,
      canvasId: 'qrCode',
      text: writeOffCode,

    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: async function () {
    var orderId = this.data.orderId;
    let order = await orderApi.getOrderById(orderId);
    this.setData({
      order: order.info,
      orderStatus: order.info.status,
    })

    if (order.info.status == 1) {
      this.createTimeClock()
    }
    if (order.info.status == 2) {
      this.drawCode(order.info.writeOffCode)
    }

  },
  rpxToPx(data) {
    return data / 750 * wx.getSystemInfoSync().windowWidth
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }

})